/* Busca em Largura sem usar operadores */
     
/*   Predicados auxiliares     */

/* d1 : ap concatena duas listas */
ap([],X,X) :- !.
ap([X|Y],Z,[X|W]) :- ap(Y,Z,W).

/* d2 : membro verifica a pertinncia a uma lista */
membro(X,[X|_]) :- !.
membro(X,[_|Y]) :- membro(X,Y).

ache_todos(X,Y,Z) :- bagof(X,Y,Z), !.
ache_todos(_,_,[]).

/* d3 : impresso de trajetrias */
imprima([r(raiz,Raiz)]) :- !,
	write('Estado Inicial: '),
	write(Raiz), write('.').
imprima([r(Ramo,Nodo)|R]) :- imprima(R), nl,
	write(Ramo), write(' e, portanto, temos: '), nl,
	write(Nodo), write('.').

/*  Predicado de chamada da soluo     */
/* d4 : Resolva vai chamar o programa que faz busca em largura */
resolva :- estado_inicial(E),
	busca([[r(raiz,E)]],Solucao),
	imprima(Solucao), nl.

/*   Critrio de busca     */
/* d5 : Realiza a busca em largura */
busca(Fila,Solucao) :- write('Busca em Largura'), nl,
	busca1(Fila,Solucao).

busca1([T|_],Solucao) :- atinge_a_meta(T), !, Solucao = T.
busca1([T|Fila],Solucao) :-
	ache_todos(ExtensaoAteUmFilho,
		   estende_ate_filho(T,ExtensaoAteUmFilho),
		   Extensoes),
	ap(Fila,Extensoes,FilaEstendida),
	busca1(FilaEstendida,Solucao).

/*    Expanso de estado por gerao de sucessores     */
/* d6: Agora trajetria  estendida   */
estende_ate_filho([r(Ramo,Nodo)|Trajetoria],
		  [r(Op,Filho),r(Ramo,Nodo)|Trajetoria]) :-
	operacao(Op,Nodo,Filho),
	nao_produz_ciclos_em(Filho,Trajetoria).

/*     Evitar buscas em ciclos      */
/* d7 : Evitar ciclos		*/
nao_produz_ciclos_em(Estado,Trajetoria) :-
	not membro(r(operacao,Estado), Trajetoria).

/*    Verificao do atendimento da meta   */
/* d8 : A trajetria que fornece a soluo atinge a meta . */
atinge_a_meta([r(Ramo,M)|_]) :- meta(M).

/*   Descrio formal do problema    */


operacao(X,Y,Z) :- X=deslisa, deslisa(Y,Z).
operacao(X,Y,Z) :- X=salta, salta(Y,Z).

deslisa([i,A,B,C,D] , [A,i,B,C,D]).
salta([i,A,B,C,D] , [B,A,i,C,D]).
deslisa([A,i,B,C,D] , [A,B,i,C,D]).
deslisa([A,i,B,C,D] , [i,A,B,C,D]).
salta([A,i,B,C,D] , [A,C,B,i,D]).
deslisa([A,B,i,C,D] , [A,i,B,C,D]).
deslisa([A,B,i,C,D] , [A,B,C,i,D]).
salta([A,B,i,C,D] , [i,B,A,C,D]).
salta([A,B,i,C,D] , [A,B,D,C,i]).
deslisa([A,B,C,i,D] , [A,B,i,C,D]).
salta([A,B,C,i,D] , [A,i,C,B,D]).
deslisa([A,B,C,i,D] , [A,B,C,D,i]).
deslisa([A,B,C,D,i] , [A,B,C,i,D]).
salta([A,B,C,D,i] , [A,B,i,D,C]).

estado_inicial([o,o,i,*,*]).
meta([o,*,*,o,i]).


