/* Busca em Largura */

/*
    Programa da pag     do livro
    Inteligencia Artificial - Um Curso Pratico, de G. Arariboia
    Turbo Prolog - An Introduction do Artifial Intelligence, de Patrice Bihan

    
*/

:- op(35,xf,e_a_meta).
:- op(35,xf,atinge_a_meta).
:- op(35,xfx,transforma).
:- op(30,xfx,a).
:- op(30,xfx,em).
:- op(35,xfx,nao_produz_ciclos_em).

ap([],X,X) :- !.
ap([X|Y],Z,[X|W]) :- ap(Y,Z,W).

membro(X,[X|_]) :- !.
membro(X,[_|Y]) :- membro(X,Y).

ache_todos(X,Y,Z) :- bagof(X,Y,Z), !.
ache_todos(_,_,[]).

imprima([r(raiz,Raiz)]) :- !,
	write('Estado Inicial: '),
	write(Raiz), write('.').
imprima([r(Ramo,Nodo)|R]) :- imprima(R), nl,
	write(Ramo), write(' e, portanto, temos: '), nl,
	write(Nodo), write('.').

resolva :- estado_inicial(E),
	busca([[r(raiz,E)]],Solucao),
	imprima(Solucao), nl.

busca(Fila,Solucao) :- write('Busca em Largura'), nl,
	busca1(Fila,Solucao).

busca1([T|_],Solucao) :- T atinge_a_meta, !, Solucao = T.
busca1([T|Fila],Solucao) :-
	ache_todos(ExtensaoAteUmFilho,
		   estende_ate_filho(T,ExtensaoAteUmFilho),
		   Extensoes),
	ap(Fila,Extensoes,FilaEstendida),
	busca1(FilaEstendida,Solucao).

estende_ate_filho([r(Ramo,Nodo)|Trajetoria],
		  [r(Op,Filho),r(Ramo,Nodo)|Trajetoria]) :-
	operacao(Op) transforma Nodo em Filho,
	Filho nao_produz_ciclos_em Trajetoria.

Estado nao_produz_ciclos_em Trajetoria :-
	not membro(r(Operacao,Estado), Trajetoria).

[r(Ramo,M)|_] atinge_a_meta :- M e_a_meta.

operacao('fazendeiro atravessa sozinho')
transforma [Saida,L,C,R] em [Chegada,L,C,R] :-
	permitido_ir_de([Saida,L,C,R] a [Chegada,L,C,R]).

operacao('fazendeiro atravessa com lobo')
transforma [Saida,Saida,C,R] em [Chegada,Chegada,C,R] :-
	permitido_ir_de([Saida,Saida,C,R] a [Chegada,Chegada,C,R]).

operacao('fazendeiro atravessa com cabra')
transforma [Saida,L,Saida,R] em [Chegada,L,Chegada,R] :-
	permitido_ir_de([Saida,L,Saida,R] a [Chegada,L,Chegada,R]).

operacao('fazendeiro atravessa com repolho')
transforma [Saida,L,C,Saida] em [Chegada,L,C,Chegada] :-
	permitido_ir_de([Saida,L,C,Saida] a [Chegada,L,C,Chegada]).

permitido_ir_de([F,L,C,R] a [F1,L1,C1,R1]) :-
	opostas(F,F1),
	nao_oferece_perigo(F1,L1,C1,R1).

nao_oferece_perigo(FC,L,FC,R).		/* fazendeiro junto com a cabra */
nao_oferece_perigo(FLR,FLR,C,FLR) :-	/* cabra sozinha em uma margem */
	opostas(FLR,C).

opostas(sul,norte).
opostas(norte,sul).

estado_inicial([norte,norte,norte,norte]).

[sul,sul,sul,sul] e_a_meta.