/* Busca em Largura */

/*
    Programa da pag     do livro
    Inteligencia Artificial - Um Curso Pratico, de G. Arariboia
    Turbo Prolog - An Introduction do Artifial Intelligence, de Patrice Bihan

*/
ap([],X,X) :- !.
ap([X|Y],Z,[X|W]) :- ap(Y,Z,W).

membro(X,[X|_]) :- !.
membro(X,[_|Y]) :- membro(X,Y).

ache_todos(X,Y,Z) :- bagof(X,Y,Z), !.
ache_todos(_,_,[]).

imprima([r(raiz,Raiz)]) :- !,
	write('Estado Inicial: '),
	write(Raiz), write('.').
imprima([r(Ramo,Nodo)|R]) :- imprima(R), nl,
	write(Ramo), write(' e, portanto, temos: '), nl,
	write(Nodo), write('.').

resolva :- estado_inicial(E),
	busca([[r(raiz,E)]],Solucao),
	imprima(Solucao), nl.

busca(Fila,Solucao) :- write('Busca em Largura'), nl,
	busca1(Fila,Solucao).

busca1([T|_],Solucao) :- atinge_a_meta(T), !, Solucao = T.
busca1([T|Fila],Solucao) :-
	ache_todos(ExtensaoAteUmFilho,
		   estende_ate_filho(T,ExtensaoAteUmFilho),
		   Extensoes),
	ap(Fila,Extensoes,FilaEstendida),
	busca1(FilaEstendida,Solucao).
/*    Expanso de estado por gerao de sucessores     */
/* d6: Agora trajetria  estendida   */
estende_ate_filho([r(Ramo,Nodo)|Trajetoria],
		  [r(Op,Filho),r(Ramo,Nodo)|Trajetoria]) :-
	operacao(Op,Nodo,Filho),
	nao_produz_ciclos_em(Filho,Trajetoria).

/*     Evitar buscas em ciclos      */
/* d7 : Evitar ciclos		*/
nao_produz_ciclos_em(Estado,Trajetoria) :-
	not membro(r(operacao,Estado), Trajetoria).

/*    Verificao do atendimento da meta   */
/* d8 : A trajetria que fornece a soluo atinge a meta . */
atinge_a_meta([r(Ramo,M)|_]) :- meta(M).


operacao(X,Y,Z) :- X=fazendeiro_sozinho, fazendeiro_sozinho(Y,Z).
operacao(X,Y,Z) :- X=fazendeiro_com_cabra, fazendeiro_com_cabra(Y,Z).
operacao(X,Y,Z) :- X=fazendeiro_com_lobo, fazendeiro_com_lobo(Y,Z).
operacao(X,Y,Z) :- X= fazendeiro_com_repolho, fazendeiro_com_repolho(Y,Z).

fazendeiro_sozinho([Saida,L,C,R], [Chegada,L,C,R]) :-
	permitido_ir_de([Saida,L,C,R],[Chegada,L,C,R]).

fazendeiro_com_lobo([Saida,Saida,C,R] , [Chegada,Chegada,C,R]) :-
	permitido_ir_de([Saida,Saida,C,R],[Chegada,Chegada,C,R]).

 fazendeiro_com_cabra([Saida,L,Saida,R] , [Chegada,L,Chegada,R]) :- 
	permitido_ir_de([Saida,L,Saida,R],[Chegada,L,Chegada,R]).

 fazendeiro_com_repolho([Saida,L,C,Saida] , [Chegada,L,C,Chegada]) :-
	permitido_ir_de([Saida,L,C,Saida],[Chegada,L,C,Chegada]).

permitido_ir_de([F,L,C,R],[F1,L1,C1,R1]) :-
	opostas(F,F1), nao_oferece_perigo(F1,L1,C1,R1).
nao_oferece_perigo(FC,L,FC,R).		/* fazendeiro junto com a cabra */
nao_oferece_perigo(FLR,FLR,C,FLR) :-	/* cabra sozinha em uma margem */
	opostas(FLR,C).


opostas(sul,norte).
opostas(norte,sul).

estado_inicial([norte,norte,norte,norte]).

/* [sul,sul,sul,sul] e_a_meta.  */
meta([sul,sul,sul,sul]).