/*
==============================================================================


               Primeiro Trabalho de Inteligencia Artificial
               -------- -------- -- ------------ ----------

               Assunto: Processamento de Lingaguem Natural

 
               Bibliografia:  Livro de IA - Arariboia
                              Capitulo 7 - pags. 169 a 176


==============================================================================
*/

/*
    Programa das pags 169 a 176  do livro
    Inteligencia Artificial - Um Curso Pratico, de G. Arariboia

   
    Predicado
      int.

    Consultas
      Escrever as consultas em linguagem natural terminando com o "string" ' ? '.
      Quando houver respostas mltiplas usar s (sim) como se fosse o ";"
      e n (no) como se fosse ".". 

*/

:- op(500,xfy,e).
:- op(400,xfx,contem).

artigo(Nc,existe(Nc,v),m,s) --> [um], !.
artigo(Nc,existe(Nc,v),f,s) --> [uma], !.
artigo(Nc,defin(Nc,v,v),m,s) --> [o], !.
artigo(Nc,defin(Nc,v,v),f,s) --> [a].

preposicao(P) --> [P], {prep(P)}, !.
preposicao(P) --> [C], {contr(C,P,Art)}, !, devolva([Art]).
preposicao(em) --> [onde], devolva([que]), !.

pronome_relativo --> [que], !.
pronome_relativo --> [quem], !.
pronome_relativo --> [o,qual], !.
pronome_relativo --> [a,qual], !.

cujo --> [cujo], devolva([um]), !.
cuja --> [cuja], devolva([uma]).

nome_comum(tp(Nome,X),G,N) --> [Nome], {n(Nome,G,N)}.
nome_comum(tp(Sinm,X),G,N) --> [Nome], {n(Nome,Sinm,G,N)}.

nome_proprio(tp(Classe,Nome),G,exige_artigo) --> [Nome], {np(Nome,art,G)},
                                                 {Classe contem Nome}.
nome_proprio(tp(Classe,Nome),G) --> [Nome], {np(Nome,G)}, {Classe contem Nome}.

verbo(s,v(Nome,prs),P) --> verbo_ligacao, art_opt, [Nome], {lig(Nome,P)}, !.
verbo(N,v(V,Tmp),P) --> [Verbo], {v(Verbo,V,N,Tmp,P)}, !.

verbo_ligacao --> [eh].
verbo_ligacao --> [era].
verbo_ligacao --> [foi].

artigo_indef(m,s) --> [um].
artigo_indef(f,s) --> [uma].

artigo_def(m,s) --> [o].
artigo_def(f,s) --> [a].

ins_art_indef(m,s,S,[um|S]).
ins_art_indef(f,s,S,[uma|S]).

art_opt --> artigo_def(_,_), !.
art_opt --> [].

frase(S,X) --> sintagma_nominal(S1,G,N,X), sintagma_verbal(S1,S,N,sx), !.
frase(S,X) --> sintagma_nominal(S1,G,N,sx), sintagma_verbal(S1,S,N,X).
frase(S,X) --> prep_sintag_nom(S2,P,X), verbo(N,V,P), sintagma_nominal(S1,G,N,sx),
               {semantica_vb(V,S1,S2,S)}.

sintagma_nominal(S,G,N,x(sn,S,N)) --> [].
sintagma_nominal(S,G,N,X) --> artigo(Nc,S1,G,N), nome_comum(Nc,G,N),
                              sintagma_preposicional(S1,S2,X),
                              relativa(S1,S3,N), {adinfo(S2,S1,S4)},
                              {adinfo(S3,S4,S)}.
sintagma_nominal(S,G,s,sx) --> nome_proprio(S,G).
sintagma_nominal(S,G,s,sx) --> artigo(_,_,G,s),nome_proprio(S,G,exige_artigo).

sintagma_preposicional(S1,S,sx) --> preposicao(P), sintagma_nominal(S2,G,N,sx),
                                    {semantica_prep(P,S1,S2,S)}.
sintagma_preposicional(S1,S,x(sp,S2,P)) --> [], {semantica_prep(P,S1,S2,S)}, !.
sintagma_preposicional(S,nenhum,_) --> [].

sintagma_verbal(S1,S,N,X) --> verbo(N,V,td), sintagma_nominal(S2,_,_,X),
                              {semantica_vb(V,S1,S2,S)}.
sintagma_verbal(S1,S,N,X) --> verbo(N,V,P), prep_sintag_nom(S2,P,X),
                              {semantica_vb(V,S1,S2,S)}.

prep_sintag_nom(S,P,X) --> preposicao(P), sintagma_nominal(S,_,_,X).
prep_sintag_nom(S,P,x(sp,S,P)) --> [].

relativa(S1,S,N) --> pronome_relativo, extrapos(sn,S1,N,X), frase(S,X).
relativa(S1,S,N) --> preposicao(P), pronome_relativo, extrapos(sp,S1,P,X), 
                     frase(S,X).
relativa(S1,S,N) --> cujo, sintagma_nominal(S2,G2,N2,sx), extrapos(sn,S2,N2,X2), 
                     frase(S3,X2), extrapos(sp,S1,de,X),
                     sintagma_preposicional(S2,S4,X), {adinfo(S3,S2,S5)},
                     {adinfo(S4,S5,S)}.
relativa(S,nenhum,_) --> [].

extrapos(C,existe(Tp,_),N,x(C,Tp,N)) --> [], !.
extrapos(C,defin(Tp,_,_),N,x(C,Tp,N)) --> [], !.
extrapos(tp(C,V),N,x(C,tp(C,V),N)).

frase(q(S)) --> frase(S,sx).
frase(q(X,S)) --> [quem], verbo_ligacao, sintagma_nominal(S,_,_,sx),
                  {nucleo(S,_,X)}, !.
frase(q(X,S)) --> [quem], devolva([uma,pessoa,que]), sintagma_nominal(S,_,_,sx),
                  {nucleo(S,_,X)}, !. 
frase(q(X,S)) --> [qual], artigo_def(G,N), ins_art_indef(G,N),
                  sintagma_nominal(S,_,_,sx), {nucleo(S,_,X)}, !.
frase(q(X,S)) --> pron_interr, ins_art_indef(_,s), frase(S,sx), {nucleo(S,_,X)}, !. 
frase(q(em(X),S)) --> [onde], devolva([um,lugar,em,que]),
                  sintagma_nominal(S,_,_,sx), {nucleo(S,_,X)}, !.
frase(q(X,S)) --> [o], [que], devolva([um,inanimado,que]),
                  sintagma_nominal(S,_,_,sx), {nucleo(S,_,X)}, !.
frase(q(de(X),S)) --> [de], [quem], devolva([uma,pessoa,de,quem]),
                  sintagma_nominal(S,_,_,sx), {nucleo(S,_,X)}, !.  

pron_interr --> [que], !.
pron_interr --> [qual].

adinfo(nenhum,S,S) :- !.
adinfo(R,existe(Tp,Alcnc), existe(Tp,NovAlcnc)) :- !, ins(R,Alcnc,NovAlcnc).
adinfo(R,defin(Tp,Press,Alcnc), defin(Tp,NovoPress,Alcnc)) :- !, ins(R,Press,NovoPress).

semantica_vb(v(V,Temp),S1,S2,S) :- !, nucleo(S1,C1,V1), nucleo(S2,C2,V2),
                                   l(V,Fn,Classe1,Classe2), Classe1 contem C1,
                                   Classe2 contem C2, R =.. [Fn,X,V1,V2],
                                   T =.. [Temp,X], ins2(R e T,S2,SR2),
                                   ins2(SR2,S1,S).

ins2(R,tp(_,_),R) :- !.
ins2(R,existe(Tp,Alcnc), existe(Tp,NovAlcnc)) :- !, ins(R,Alcnc,NovAlcnc).
ins2(R,defin(Tp,Press,Alcnc), defin(Tp,Press,NovAlcnc)) :- !, ins(R,Alcnc,NovAlcnc).

semantica_prep(P,S1,S2,S) :- !, nucleo(S1,C1,V1), nucleo(S2,C2,V2), 
                             encontre_ligacao(P,C1,C2,L), R =.. [L,V1,V2], ins2(R,S2,S).

encontre_ligacao(P,C1,C2,L) :- lig(C1,P), l(C1,L,Classe1,Classe2), Classe1 contem C1,
                                   Classe2 contem C2, !. 
encontre_ligacao(P,C1,C2,L) :- l(P,L,Classe1,Classe2), Classe1 contem C1,  
                               Classe2 contem C2.

X contem X :- !.
X contem Y :- c(X,Z), Z contem Y.

ins(R e T,Pred,R e T e Pred) :- !.
ins(R,Pred,R e Pred).

nucleo(tp(Classe,Nome),Classe,Nome) :- !.
nucleo(existe(tp(Classe,Var),P),Classe,Var) :- !.
nucleo(defin(tp(Classe,Var),X,Y),Classe,Var).

devolva([],S,S) :- !.
devolva([X|Y],Z,[X|W]) :- devolva(Y,Z,W).

/* Genero e numero dos nomes comuns */
n(pessoa,f,s).
n(homem,m,s).
n(marido,m,s).
n(esposa,f,s).
n(pai,m,s).
n(mae,f,s).
n(filho,m,s).
n(filha,f,s).
n(avo,m,s).
n(mulher,f,s).
n(deus,m,s).
n(deusa,f,s).
n(monstro,m,s).
n(animal,m,s).
n(sereia,f,s).
n(ciclope,m,s).
n(ilha,f,s).
n(cidade,f,s).
n(monte,m,s).
n(montanha,monte,f,s).
n(muralha,f,s).
n(lugar,m,s).
n(coisa,f,s).
n(inanimado,m,s).
n(olho,m,s).

/* Genero dos nomes proprios */
np(troia,f).
np(posseidon,m).
np(zeus,m).
np(polifemo,m).
np(odisseus,m).
np(atenas,f).
np(juno,f).
np(afrodite,f).
np(olimpo,art,m).
np(oceano,art,m).
np(aquiles,m).
np(heitor,m).
np(paris,m).
np(menelau,m).
np(helena,f).
np(penelope,f).
np(telemaco,m).
np(itaca,f).
np(calipso,f).
np(priamo,m).
np(andromaca,f).

/* Preposicao e contracoes */
prep(de).
prep(com).
prep(em).
prep(a).
prep(para).

contr(do,de,o).
contr(da,de,a).
contr(no,em,o).
contr(na,em,a).

/* Tempo, numero e regencia de verbos */

v(eh,ser,s,prs,td).
v(era,ser,s,imp,td).
v(mora,morar,s,prs,em).
v(morava,morar,s,imp,em).
v(morou,morar,s,imp,em).
v(vive,viver,s,prs,em).
v(vivia,viver,s,imp,em).
v(viveu,viver,s,imp,em).
v(visitou,visitar,s,prf,td).
v(foi,ir,s,prf,a).
v(protege,proteger,s,prs,td).
v(protegia,proteger,s,imp,td).
v(defende,defender,s,prs,td).
v(defendia,defender,s,imp,td).
v(ama,amar,s,prs,td).
v(amava,amar,s,imp,td).
v(amou,amar,s,imp,td).
v(gostava,gostar,s,imp,de).
v(gosta,gostar,s,prs,de).
v(matou,matar,s,prf,td).
v(odeia,odiar,s,prs,td).
v(odiava,odiar,s,imp,td).
v(odiou,odiar,s,imp,td).
v(furou,furar,s,prf,td).
v(cegou,cegar,s,prf,td).
v(raptou,raptar,s,prf,td).
v(feriu,ferir,s,prf,td).
v(machucou,ferir,s,prf,td).

/* Nomes que expressam relacoes */
lig(pai,de).
lig(mae,de).
lig(filho,de).
lig(filha,de).
lig(avo,de).
lig(esposa,de).
lig(mulher,de).

/* Coneccoes estabelecidas por verbos e nomes */
l(ser,identico,coisa,coisa).
l(odiar,odeia,pessoa,coisa).
l(morar,moradia,animal,lugar).
l(ir,vai,pessoa,lugar).
l(visitar,vai,pessoa,lugar).
l(visitar,visita,pessoa,pessoa).
l(defender,defende,animal,coisa).
l(proteger,defende,animal,coisa).
l(proteger,defesa,inanimado,coisa).
l(defender,defesa,inanimado,coisa).
l(amar,ama,pessoa,pessoa).
l(amar,gosta,pessoa,inanimado).
l(gostar,gosta,pessoa,coisa).
l(matar,mata,animal,animal).
l(pai,pai,animal,animal).
l(mae,mae,animal,animal).
l(filho,filho,animal,animal).
l(filha,filha,animal,animal).
l(avo,avo,animal,animal).
l(mulher,esposa,pessoa,pessoa).
l(esposa,esposa,pessoa,pessoa).
l(marido,marido,pessoa,pessoa).
l(de,origem,pessoa,lugar).
l(de,posse,lugar,pessoa).
l(de,posse,inanimado,pessoa).
l(cegar,cega,coisa,animal).
l(furar,fura,animal,coisa).
l(raptar,rapto,pessoa,pessoa).
l(ferir,fere,animal,animal).

/* Rede semantica */
c(homem,pai).
c(homem,avo).
c(homem,filho).
c(mulher,filha).
c(mulher,mae).
c(homem,marido).
c(pessoa,homem).
c(pessoa,mulher).
c(mulher,esposa).
c(mulher,deusa).
c(homem,deus).
c(animal,pessoa).
c(coisa,animal).
c(lugar,oceano).
c(lugar,ilha). 
c(monte,olimpo).
c(lugar,monte).
c(lugar,cidade).
c(inanimado,lugar).
c(coisa,inanimado).
c(inanimado,muralha).
c(inanimado,olho).
c(cidade,troia).
c(deus,posseidon).
c(deus,zeus).
c(ciclope,polifemo).
c(homem,odisseus).
c(deusa,atenas).
c(homem,aquiles).
c(homem,heitor).
c(mulher,helena).
c(mulher,penelope).
c(homem,telemaco).
c(ilha,itaca).
c(deusa,calipso).
c(homem,ciclope).
c(homem,paris).
c(homem,priamo).
c(homem,menelau).
c(mulher,andromaca).

:- op(400,xfx,[eh,eh_um]).

interprete(q(S)) :- call(S), nl, write(sim), nl, !.
interprete(q(X,tp(X,X))) :- !, nl, write('Resposta: '), mostre1(X), nl,
                            write('Quer outra resposta ?'), nao_quer, !.
interprete(q(X,S)) :- call(S), nl, write('Resposta: '), mostre(X), nl,
                            write('Quer outra resposta ?'), nao_quer, !.
interprete(_) :- nl, write('Faltam dados'), nl.

mostre(em(X)) :- descreva(X,Y), write('em '), write(Y), !.
mostre(de(X)) :- descreva(X,Y), write('de '), write(Y), !.
mostre(X) :- descreva(X,Y), write(Y), !.

descreva(X,Y) :- descr(X,Y), !.
descreva(X,X).

mostre1(X) :- descr1(X,D), !, write(D).
mostre1(X) :- fr(X,D,F,[]), escrever_resp(F).

escrever_resp([]) :- !.
escrever_resp([X|Y]) :- write(X), write(' '), escrever_resp(Y).

X eh_um Y :- c(Y,X).
X eh_um Y :- c(Z,X), Z eh_um Y.

int :- repeat, nl, write('> '), ana_lex(X), trad(S,X), interprete(S), fail.

trad(S,X) :- frase(S,X,[?]), !.
trad(S,C) :- nl, write('Nao entendi a pergunta.'), fail.

nao_quer :- repeat, write(' sim (s) ou nao (n) ?'), nl, get0(X), (X==115; X==110), !, nl,
            X=110.

v.
P e Q :- call(P), call(Q).
existe(tp(Clss,X),S) :- call(S), X eh Clss.
defin(tp(Clss,X),Press,Alcnc) :- call(Press), X eh Clss, call(Alcnc).
fr(X,Y) --> { X eh_um Y}, sint_nom(X), verbo, sint_nom(Y).

sint_nom(X) --> artigo_indef(G,N), nome_com(G,X).
sint_nom(X) --> nome_prop(X).

nome_com(G,X) --> [X], { n(X,G,_)}.

nome_prop(X) --> [X], {np(X,_)}.
nome_prop(X) --> artigo_def(G,N), [X], {np(X,art,G)}.

verbo --> [eh].

prf(X) :- Fn =.. [X,prf], call(Fn).
imp(X) :- Fn =.. [X,imp], call(Fn).
prs(X) :- imp(X).

prot1(imp).
prot1(prf).
prot2(imp).
prot2(prf).

defende(prot1,atenas,odisseus).
defende(prot1,atenas,penelope).
defende(prot1,atenas,itaca).
defende(prot1,atenas,telemaco).
defende(prot2,heitor,troia).

defs1(imp).
defs1(prf).
defesa(defs1,muralha:1,troia).

odio1(imp).
odio2(imp).
odeia(odio1,posseidon,odisseus).
odeia(odio1,polifemo,odisseus).
odeia(odio2,odisseus,polifemo).

mora1(imp).
mora1(prf).
mora2(imp).
mora2(prf).
mora3(imp).
mora3(prf).
mora4(imp).
mora4(prf).
mora5(imp).
mora5(prf).
moradia(mora1,odisseus,itaca).
moradia(mora2,calipso,ilha:1).
moradia(mora1,penelope,itaca).
moradia(mora1,telemaco,itaca).
moradia(mora3,polifemo,ilha:2).
moradia(mora4,posseidon,oceano).
moradia(mora5,atenas,olimpo).
moradia(mora5,zeus,olimpo).

ida1(prf).
ida2(prf).
ida3(prf).
vai(ida1,atenas,itaca).
vai(ida2,odisseus,ilha:1).
vai(ida3,odisseus,ilha:2).

vis1(prf).
visita(vis1,atenas,telemaco).

amor1(imp).
amor1(prf).
amor2(imp).
amor2(prf).
ama(amor1,penelope,odisseus).
ama(amor2,calipso,odisseus).
ama(amor1,odisseus,penelope).

gostar1(imp).
gostar1(prf).
gosta(X,Y,Z) :- ama(X,Y,Z).
gosta(gostar1,atenas,odisseus).

morte1(prf).
mata(morte1,aquiles,heitor).

cega1(prf).
cega(cega1,odisseus,polifemo).

fura1(prf).
fura(fura1,odisseus,olho:1).

destr1(prf).
destroi(destr1,odisseus,troia).

ident(X).
identico(indent,X,Y) :- X eh_um Y.

fere(Conc,Pessoa1, Pessoa2) :- cega(Conc, Pessoa1, Pessoa2).

pai(odisseus,telemaco).
pai(posseidon,polifemo).
pai(zeus,atenas).

esposa(penelope,odisseus).
marido(X,Y) :- esposa(Y,X).

filho(X,Y) :- (pai(Y,X); mae(Y,X)), homem contem X.
filha(X,Y) :- (pai(Y,X); mae(Y,X)), mulher contem X.

mae(penelope,telemaco).

ser(imp).
pai(ser,X,Y) :- pai(X,Y).
mae(ser,X,Y) :- mae(X,Y).
filho(ser,X,Y) :- filho(X,Y).
filha(ser,X,Y) :- filha(X,Y).
esposa(ser,X,Y) :- esposa(X,Y).
marido(ser,X,Y) :- marido(X,Y).

origem(atenas,olimpo).
origem(odisseus,itaca).
origem(telemaco,itaca).
origem(penelope,itaca).

posse(itaca,odisseus).
posse(itaca,telemaco).
posse(ilha:1,calipso).
posse(ilha:2,polifemo).
posse(olho:1,polifemo).

X eh filho :- filho(X,Y), !.
X eh pai :- pai(X,Y), !.
X eh esposa :- esposa(X,Y), !.
X eh marido :- marido(X,Y), !.
(X:Y) eh Z :- !, Z contem X.
X eh Y :- Y contem X.

descr(ilha:1, 'uma ilha bonita').
descr(ilha:2, 'uma ilha deserta').
descr(olho:1, 'unico olho de Polifemo').
descr(muralha:1, 'uma muralha construida por Posseidon').

descr1(polifemo, 'Um ciclope filho de Posseidon').
descr1(odisseus, 'heroi da Odisseia, um poema de Homero').
descr1(penelope, 'Esposa de Odisseus. Heroina de Odisseia').
descr1(telemaco, 'Filho de Odisseus e de Penelope').
descr1(posseidon, 'Um deus que odiava Odisseus').
descr1(atenas, 'Uma deusa que protegia Odisseus').
descr1(calipso, 'Uma deusa que amava Odisseus').

leia(Letra,X,R) :- retrocede(Letra), !, apag_letra(X,X1), le_tecla(Prox),
                   leia(Prox,X1,R).
leia(Letra,X,R) :- branco(Letra), !, le_tecla(Prox), leia(Prox,[32|X],R).
leia(Letra,X,[Letra|X]) :- termino(Letra), !.
leia(Letra,X,R) :- le_tecla(Prox), leia(Prox,[Letra|X],R).

apag_letra([],[]) :- !.
apag_letra([X|Y],Y) :- put(` `), put(8).

ana_lex(L) :- le_tecla(Letra), leia(Letra,[],Lista), compacte(Lista,[],L).
retrocede(8).

branco(X) :- [X] == ",", !.
branco(13) :- !.
branco(X) :- X < 33.

termino(X) :- [X] == ".", !.
termino(X) :- [X] == "?".

compacte(S,L,L) :- ignore_brancos(S,S1), S1=[], !.
compacte(X,L,R) :- ignore_brancos(X,X2), tire_um(X2,[],X1,Pal), name(Nom,Pal),
                   compacte(X1,[Nom|L],R).

tire_um([S|R],[],R,[S]) :- termino(S), !.
tire_um([S|R],L,[S|R],L) :- termino(S), !.
tire_um([],L,[],L) :- !.
tire_um([B|R],L,R,L) :- branco(B), !.
tire_um([Lt|Ra],L,R,Pal) :- tire_um(Ra,[Lt|L],R,Pal).

ignore_brancos([],[]) :- !.
ignore_brancos([X|R],[X|R]) :- not branco(X), !.
ignore_brancos([B|R],S) :- ignore_brancos(R,S).

le_tecla(X) :- get0(Y), conv_para_minusc(Y,X).

conv_para_minusc(Y,X) :- [A] = "A", [Z] = "Z", Y >= A, Y =< Z, X is Y+32, !.
conv_para_minusc(Y,Y).
